Index: branches/libIGCM_MPI_OpenMP/libIGCM_comp/libIGCM_comp.ksh
===================================================================
--- branches/libIGCM_MPI_OpenMP/libIGCM_comp/libIGCM_comp.ksh	(revision 570)
+++ branches/libIGCM_MPI_OpenMP/libIGCM_comp/libIGCM_comp.ksh	(revision 571)
@@ -405,84 +442,90 @@
 function IGCM_comp_GetInputBoundaryFiles
 {
-    IGCM_debug_PushStack "IGCM_comp_GetInputBoundaryFiles"
+  IGCM_debug_PushStack "IGCM_comp_GetInputBoundaryFiles"
+
+  # Debug Print :
+  echo
+  IGCM_debug_Print 1 "IGCM_comp_GetInputBoundaryFiles"
+  echo
+
+  typeset comp compname comptagname card ListFilesName FileName0 NbFiles i i_ 
+  typeset file_in_ file_in file_out_ file_out 
+
+  if [ ${Period} = 1 ]; then
+    ListFixBoundary=" "
+  fi
+
+  for comp in ${config_ListOfComponents[*]} ; do
+
+    # Define component
+    eval compname=\${config_ListOfComponents_${comp}[0]} > /dev/null 2>&1
+    eval comptagname=\${config_ListOfComponents_${comp}[1]} > /dev/null 2>&1
 
     # Debug Print :
-    echo
-    IGCM_debug_Print 1 "IGCM_comp_GetInputBoundaryFiles"
-    echo
-
-    typeset comp compname comptagname card ListFilesName FileName0 NbFiles i i_ 
-    typeset file_in_ file_in file_out_ file_out 
-
+    IGCM_debug_Print 3 "Boundary files ${compname}"
+
+    card=${SUBMIT_DIR}/COMP/${compname}.card
+
+    IGCM_card_DefineArrayFromOption ${card} BoundaryFiles List
+    ListFilesName=${compname}_BoundaryFiles_List
+    eval FileName0=\${${ListFilesName}[0]} > /dev/null 2>&1
+
+    if [ X${FileName0} != X${NULL_STR} ] ; then
+      eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
+
+      (( i=0 ))
+      until [ $i -ge $NbFiles ]; do
+	eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
+	eval file_in=${file_in_}
+	(( i_ = i+1 ))
+	eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
+	eval file_out=${file_out_}
+
+	IGCM_sys_Get ${file_in} ${file_out}
+	IGCM_comp_PrepareDeletedFiles ${file_in} ${file_out}
+
+	(( i=i+2 ))
+      done
+    fi
+
+    # Get non deleted files
     if [ ${Period} = 1 ]; then
-	ListFixBoundary=" "
-    fi
-
-    for comp in ${config_ListOfComponents[*]} ; do
-
-	# Define component
-	eval compname=\${config_ListOfComponents_${comp}[0]} > /dev/null 2>&1
-	eval comptagname=\${config_ListOfComponents_${comp}[1]} > /dev/null 2>&1
-
-        # Debug Print :
-	IGCM_debug_Print 3 "Boundary files ${compname}"
-
-	card=${SUBMIT_DIR}/COMP/${compname}.card
-
-	IGCM_card_DefineArrayFromOption ${card} BoundaryFiles List
-	ListFilesName=${compname}_BoundaryFiles_List
- 	eval FileName0=\${${ListFilesName}[0]} > /dev/null 2>&1
-
-	if [ X${FileName0} != X${NULL_STR} ] ; then
-	    eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
-
-	    (( i=0 ))
-	    until [ $i -ge $NbFiles ]; do
-		eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
-		eval file_in=${file_in_}
-		(( i_ = i+1 ))
-		eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
-		eval file_out=${file_out_}
-
-		IGCM_sys_Get ${file_in} ${file_out}
-		IGCM_comp_PrepareDeletedFiles ${file_in} ${file_out}
-
-		(( i=i+2 ))
-	    done
-	fi
-
-	# Get non deleted files
-	if [ ${Period} = 1 ]; then
-
-	    IGCM_card_DefineArrayFromOption ${card} BoundaryFiles ListNonDel
-	    ListFilesName=${compname}_BoundaryFiles_ListNonDel
-	    eval FileName0=\${${ListFilesName}[0]} > /dev/null 2>&1
-	    
-	    if [ X${FileName0} != X${NULL_STR} ] ; then
-		eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
-		
-		(( i=0 ))
-		until [ $i -ge $NbFiles ]; do
-		    eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
-		    eval file_in=${file_in_}
-		    (( i_ = i+1 ))
-		    eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
-		    eval file_out=${file_out_}
-
-		    IGCM_sys_Get ${file_in} ${file_out}
-
-		    if [ X${file_out} != X. ] ; then
-			ListFixBoundary=${ListFixBoundary}" "${file_out}
-		    else
-			ListFixBoundary=${ListFixBoundary}" "$( basename ${file_in} )
-		    fi
-
-		    (( i=i+2 ))
-		done
-	    fi
-	fi
-    done
-    
-    IGCM_debug_PopStack "IGCM_comp_GetInputBoundaryFiles"
+
+      IGCM_card_DefineArrayFromOption ${card} BoundaryFiles ListNonDel
+      ListFilesName=${compname}_BoundaryFiles_ListNonDel
+      eval FileName0=\${${ListFilesName}[0]} > /dev/null 2>&1
+      
+      if [ X${FileName0} != X${NULL_STR} ] ; then
+	eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
+	
+	(( i=0 ))
+	until [ $i -ge $NbFiles ]; do
+	  eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
+	  eval file_in=${file_in_}
+	  (( i_ = i+1 ))
+	  eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
+	  eval file_out=${file_out_}
+
+	  IGCM_sys_IsFileArchived ${file_in}
+	  if [ $? = 0 ] ; then
+	    IGCM_sys_Get ${file_in} ${file_out}
+	    #IGCM_comp_PrepareDeletedFiles ${file_in} ${file_out}
+	  else
+	    IGCM_sys_Cp ${file_in} ${file_out}
+	  fi
+
+	  if [ X${file_out} != X. ] ; then
+	    ListFixBoundary=${ListFixBoundary}" "${file_out}
+	  else
+	    ListFixBoundary=${ListFixBoundary}" "$( basename ${file_in} )
+	  fi
+
+	  (( i=i+2 ))
+	done
+      fi
+    fi
+  done
+  
+  IGCM_debug_PopStack "IGCM_comp_GetInputBoundaryFiles"
 }
 
@@ -490,15 +533,15 @@
 function IGCM_comp_DelFixeBoundaryFiles
 {
-    IGCM_debug_PushStack "IGCM_comp_DelFixeBoundaryFiles"
-
-    # Debug Print :
-    echo
-    IGCM_debug_Print 1 "IGCM_comp_DelFixeBoundaryFiles"
-    echo
-
-    ls -l ${ListFixBoundary}
-    rm -f ${ListFixBoundary}
-
-    IGCM_debug_PopStack "IGCM_comp_DelFixeBoundaryFiles"
+  IGCM_debug_PushStack "IGCM_comp_DelFixeBoundaryFiles"
+
+  # Debug Print :
+  echo
+  IGCM_debug_Print 1 "IGCM_comp_DelFixeBoundaryFiles"
+  echo
+
+  ls -l ${ListFixBoundary}
+  rm -f ${ListFixBoundary}
+
+  IGCM_debug_PopStack "IGCM_comp_DelFixeBoundaryFiles"
 }
 
@@ -506,46 +549,46 @@
 function IGCM_comp_GetInputParametersFiles
 {
-    IGCM_debug_PushStack "IGCM_comp_GetInputParametersFiles"
+  IGCM_debug_PushStack "IGCM_comp_GetInputParametersFiles"
+
+  # Debug Print :
+  echo
+  IGCM_debug_Print 1 "IGCM_comp_GetInputParametersFiles"
+  echo
+
+  typeset comp compname comptagname card ListFilesName FileName0 NbFiles i i_ file_in file_out
+  for comp in ${config_ListOfComponents[*]} ; do
+    # Define component 
+    eval compname=\${config_ListOfComponents_${comp}[0]} > /dev/null 2>&1
+    eval comptagname=\${config_ListOfComponents_${comp}[1]} > /dev/null 2>&1
 
     # Debug Print :
-    echo
-    IGCM_debug_Print 1 "IGCM_comp_GetInputParametersFiles"
-    echo
-
-    typeset comp compname comptagname card ListFilesName FileName0 NbFiles i i_ file_in file_out
-    for comp in ${config_ListOfComponents[*]} ; do
-	# Define component 
-	eval compname=\${config_ListOfComponents_${comp}[0]} > /dev/null 2>&1
-	eval comptagname=\${config_ListOfComponents_${comp}[1]} > /dev/null 2>&1
-
-	# Debug Print :
-	IGCM_debug_Print 3 "Parameters ${compname}"
-
-	card=${SUBMIT_DIR}/COMP/${compname}.card	
-
-	IGCM_card_DefineArrayFromOption ${card} ParametersFiles List
-	ListFilesName=${compname}_ParametersFiles_List
- 	eval FileName0=\${${ListFilesName}[0]} > /dev/null 2>&1
-
-	if [ X${FileName0} != X${NULL_STR} ] ; then
-	    eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
-
-	    (( i=0 ))
-	    until [ $i -ge $NbFiles ]; do
-		eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
-		eval file_in=${file_in_}
-		(( i_ = i+1 ))
-		eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
-		eval file_out=${file_out_} 
-
-		IGCM_sys_Cp ${file_in} ${file_out} 
-		IGCM_comp_PrepareDeletedFiles ${file_in} ${file_out}
-
-		(( i=i+2 ))
-	    done
-	fi
-    done
-
-    IGCM_debug_PopStack "IGCM_comp_GetInputParametersFiles"
+    IGCM_debug_Print 3 "Parameters ${compname}"
+
+    card=${SUBMIT_DIR}/COMP/${compname}.card	
+
+    IGCM_card_DefineArrayFromOption ${card} ParametersFiles List
+    ListFilesName=${compname}_ParametersFiles_List
+    eval FileName0=\${${ListFilesName}[0]} > /dev/null 2>&1
+
+    if [ X${FileName0} != X${NULL_STR} ] ; then
+      eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
+
+      (( i=0 ))
+      until [ $i -ge $NbFiles ]; do
+	eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
+	eval file_in=${file_in_}
+	(( i_ = i+1 ))
+	eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
+	eval file_out=${file_out_} 
+
+	IGCM_sys_Cp ${file_in} ${file_out} 
+	IGCM_comp_PrepareDeletedFiles ${file_in} ${file_out}
+
+	(( i=i+2 ))
+      done
+    fi
+  done
+
+  IGCM_debug_PopStack "IGCM_comp_GetInputParametersFiles"
 }
 
@@ -553,167 +596,178 @@
 function IGCM_comp_GetInputRestartFiles
 {
-    IGCM_debug_PushStack "IGCM_comp_GetInputRestartFiles"
+  IGCM_debug_PushStack "IGCM_comp_GetInputRestartFiles"
+
+  # Debug Print :
+  echo
+  IGCM_debug_Print 1 "IGCM_comp_GetInputRestartFiles"
+  echo
+
+  typeset Date_tmp Date_r Path_r do_start CompOldName Path_OUT Path_BUF Buffered
+  typeset comp compname comptagname card ListFilesName FileName0 NbFiles i i_ 
+  typeset file_in file_out file_in_ file_out_ file_in_Name
+  typeset -Z4 j4
+
+  for comp in ${config_ListOfComponents[*]} ; do
+    # Define component 
+    eval compname=\${config_ListOfComponents_${comp}[0]} > /dev/null 2>&1
+    eval comptagname=\${config_ListOfComponents_${comp}[1]} > /dev/null 2>&1
+    #
+    card=${SUBMIT_DIR}/COMP/${compname}.card
+    #
+    IGCM_card_DefineArrayFromOption ${card} RestartFiles List
+    ListFilesName=${compname}_RestartFiles_List
+    eval FileName0=\${${ListFilesName}[0]} > /dev/null 2>&1
 
     # Debug Print :
-    echo
-    IGCM_debug_Print 1 "IGCM_comp_GetInputRestartFiles"
-    echo
-
-    typeset Date_tmp Date_r Path_r do_start CompOldName Path_temp
-    typeset comp compname comptagname card ListFilesName FileName0 NbFiles i i_ 
-    typeset file_in file_out file_in_ file_out_ file_in_Name
-    typeset -Z4 j4
-
-    for comp in ${config_ListOfComponents[*]} ; do
-	# Define component 
-	eval compname=\${config_ListOfComponents_${comp}[0]} > /dev/null 2>&1
-	eval comptagname=\${config_ListOfComponents_${comp}[1]} > /dev/null 2>&1
-	#
-	card=${SUBMIT_DIR}/COMP/${compname}.card
-	#
-	IGCM_card_DefineArrayFromOption ${card} RestartFiles List
-	ListFilesName=${compname}_RestartFiles_List
-	eval FileName0=\${${ListFilesName}[0]} > /dev/null 2>&1
-
-	# Debug Print :
-	IGCM_debug_Print 3 "restart ${compname}"
-
-	if ( ${FirstInitialize} ) ; then
-
-	    if [ "${config_Restarts_OverRule}" = "y" ] ; then
-		eval config_${comp}_Restart="y"
-		eval config_${comp}_RestartDate=${config_Restarts_RestartDate}
-		eval config_${comp}_RestartJobName=${config_Restarts_RestartJobName}
-		eval config_${comp}_RestartPath=${config_Restarts_RestartPath}
-		eval do_start=\${config_${comp}_Restart} > /dev/null 2>&1
-		eval CompOldName=${comp}
+    IGCM_debug_Print 3 "restart ${compname}"
+
+    if ( ${FirstInitialize} ) ; then
+
+      if [ "${config_Restarts_OverRule}" = "y" ] ; then
+	eval config_${comp}_Restart="y"
+	eval config_${comp}_RestartDate=${config_Restarts_RestartDate}
+	eval config_${comp}_RestartJobName=${config_Restarts_RestartJobName}
+	eval config_${comp}_RestartPath=${config_Restarts_RestartPath}
+	eval do_start=\${config_${comp}_Restart} > /dev/null 2>&1
+	eval CompOldName=${comp}
+      else
+	        # Read component Restarts parameters
+	IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/config.card ${comp} Restart
+	eval do_start=\${config_${comp}_Restart} > /dev/null 2>&1
+
+	if [ "${do_start}" = "y" ] ; then
+	  IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/config.card ${comp} RestartDate
+	  IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/config.card ${comp} RestartJobName
+	  IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/config.card ${comp} RestartPath
+	else
+	  eval config_${comp}_RestartDate=-1
+	  eval config_${comp}_RestartJobName=${NULL_STR}
+	  eval config_${comp}_RestartPath=${NULL_STR}
+	fi
+	IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/config.card ${comp} OldName
+	eval CompOldName=\${config_${comp}_OldName}
+	if [ X${CompOldName} = X ] ; then
+	  eval CompOldName=${comp}
+	fi
+      fi
+
+      if [ "${do_start}" = "y" ] ; then
+
+	if ( [ X${FileName0} != X${NULL_STR} ] && [ X${FileName0} != XNONE ] ) ; then
+	  eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
+
+	  (( i=1 ))
+	  until [ $i -gt $NbFiles ]; do
+	    eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
+	    eval file_in=${file_in_}
+
+	    (( i_ = i+1 ))
+	    eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
+	    eval file_out=${file_out_}
+	    
+	    eval Date_tmp=\${config_${comp}_RestartDate}
+	    Date_r=$( IGCM_date_ConvertFormatToGregorian ${Date_tmp} )
+	    eval Path_r=\${config_${comp}_RestartPath}/\${config_${comp}_RestartJobName}/${CompOldName}/Restart
+	    eval file_in_Name=\${config_${comp}_RestartJobName}_${Date_r}_${file_in}
+
+	    generic_restart_file_name_in=$( basename ${file_in_Name} .nc )
+	    generic_restart_file_name_out=$( basename ${file_out} .nc )
+	    
+	    eval Path_OUT=\${Path_r}/${generic_restart_file_name_in}
+	    nb_restart_file=$(IGCM_sys_CountFileArchive ${Path_OUT}_????.nc)
+
+	    if [ ${nb_restart_file} -gt 1 ] ; then
+	      j=0
+	      until [ $j -ge $nb_restart_file ]; do
+		j4=${j}
+		eval IGCM_sys_Get ${Path_r}/${generic_restart_file_name_in}_${j4}.nc ${generic_restart_file_name_out}_${j4}.nc
+		#IGCM_comp_PrepareDeletedFiles ${generic_restart_file_name_in}_${j4}.nc ${generic_restart_file_name_out}_${j4}.nc
+		#eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${generic_restart_file_name_out}_${j4}.nc" > /dev/null 2>&1
+		(( j=j+1 ))
+	      done
 	    else
-	        # Read component Restarts parameters
-		IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/config.card ${comp} Restart
-		eval do_start=\${config_${comp}_Restart} > /dev/null 2>&1
-
-		if [ "${do_start}" = "y" ] ; then
-		    IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/config.card ${comp} RestartDate
-		    IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/config.card ${comp} RestartJobName
-		    IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/config.card ${comp} RestartPath
-		else
-		    eval config_${comp}_RestartDate=-1
-		    eval config_${comp}_RestartJobName=${NULL_STR}
-		    eval config_${comp}_RestartPath=${NULL_STR}
-		fi
-		IGCM_card_DefineVariableFromOption ${SUBMIT_DIR}/config.card ${comp} OldName
-		eval CompOldName=\${config_${comp}_OldName}
-		if [ X${CompOldName} = X ] ; then
-		    eval CompOldName=${comp}
-		fi
-	    fi
-
-	    if [ "${do_start}" = "y" ] ; then
-
-		if ( [ X${FileName0} != X${NULL_STR} ] && [ X${FileName0} != XNONE ] ) ; then
-		    eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
-
-		    (( i=1 ))
-		    until [ $i -gt $NbFiles ]; do
-			eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
-			eval file_in=${file_in_}
-
-			(( i_ = i+1 ))
-			eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
-			eval file_out=${file_out_}
-			
-			eval Date_tmp=\${config_${comp}_RestartDate}
-			Date_r=$( IGCM_date_ConvertFormatToGregorian ${Date_tmp} )
-			eval Path_r=\${config_${comp}_RestartPath}/\${config_${comp}_RestartJobName}/${CompOldName}/Restart
-			eval file_in_Name=\${config_${comp}_RestartJobName}_${Date_r}_${file_in}
-
-			generic_restart_file_name_in=$( basename ${file_in_Name} .nc )
-			generic_restart_file_name_out=$( basename ${file_out} .nc )
-			
-			eval Path_temp=\${Path_r}/${generic_restart_file_name_in}
-			nb_restart_file=$(IGCM_sys_CountFileArchive ${Path_temp}_????.nc)
-
-			if [ ${nb_restart_file} -gt 1 ] ; then
-			    j=0
-			    until [ $j -ge $nb_restart_file ]; do
-				j4=${j}
-				eval IGCM_sys_Get ${Path_r}/${generic_restart_file_name_in}_${j4}.nc ${generic_restart_file_name_out}_${j4}.nc
-				#IGCM_comp_PrepareDeletedFiles ${generic_restart_file_name_in}_${j4}.nc ${generic_restart_file_name_out}_${j4}.nc
-				#eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${generic_restart_file_name_out}_${j4}.nc" > /dev/null 2>&1
-				(( j=j+1 ))
-			    done
-			else
-			    eval IGCM_sys_Get ${Path_r}/${file_in_Name} ${file_out}  
-			    #IGCM_comp_PrepareDeletedFiles ${file_in} ${file_out}
-			fi
-		
-			(( i=i+3 ))
-		    done
-		else
-		    if [ X${FileName0} != XNONE ] ; then
-			IGCM_debug_Exit "IGCM_comp_GetInputRestartFiles : No file in list for ${compname}."
-		    else
-			IGCM_debug_Print 1 "IGCM_comp_GetInputRestartFiles : NONE specified in Restart List ${compname}."
-		    fi
-		fi
-	    fi
-	elif [ ${Period} -eq 1 ] ; then
-            # if not FirstInitialize and first loop of this job
-
-	    # Restore Restarts files
-	    #-----------------------
-	    if ( [ X${FileName0} != X${NULL_STR} ] && [ X${FileName0} != XNONE ] ) ; then
-		eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
-
-		(( i=1 ))
-		until [ $i -gt $NbFiles ]; do
-		    eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
-		    eval file_in=${file_in_}
-		    (( i_ = i+1 ))
-		    eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
-		    eval file_out=${file_out_}
-		    
-		    file_in_Name=${run_Configuration_OldPrefix}_${file_in}
-
-		    generic_restart_file_name_in=$( basename ${file_in_Name} .nc )
-		    generic_restart_file_name_out=$( basename ${file_out} .nc )
-
-		    eval Path_temp=\${R_OUT_${comp}_R}/${generic_restart_file_name_in}
-		    nb_restart_file=$(IGCM_sys_CountFileArchive ${Path_temp}_????.nc)
-
-		    if [ ${nb_restart_file} -gt 1 ] ; then
-			j=0
-			until [ $j -ge $nb_restart_file ]; do
-			    j4=${j}
-			    eval IGCM_sys_Get \${R_OUT_${comp}_R}/${generic_restart_file_name_in}_${j4}.nc ${generic_restart_file_name_out}_${j4}.nc
-			    #IGCM_comp_PrepareDeletedFiles ${generic_restart_file_name_in}_${j4}.nc ${generic_restart_file_name_out}_${j4}.nc
-			    #eval FileToBeDeleted[${#FileToBeDeleted[@]}]="${generic_restart_file_name_out}_${j4}.nc" > /dev/null 2>&1
-
-			    (( j=j+1 ))
-			done
-		    else
-			eval IGCM_sys_Get \${R_OUT_${comp}_R}/${file_in_Name} ${file_out}
-			#IGCM_comp_PrepareDeletedFiles ${file_in} ${file_out}
-		    fi
-
-		    (( i=i+3 ))
-		done
+	      eval IGCM_sys_Get ${Path_r}/${file_in_Name} ${file_out}  
+	      #IGCM_comp_PrepareDeletedFiles ${file_in} ${file_out}
+	    fi
+	    
+	    (( i=i+3 ))
+	  done
+	else
+	  if [ X${FileName0} != XNONE ] ; then
+	    IGCM_debug_Exit "IGCM_comp_GetInputRestartFiles : No file in list for ${compname}."
+	  else
+	    IGCM_debug_Print 1 "IGCM_comp_GetInputRestartFiles : NONE specified in Restart List ${compname}."
+	  fi
+	fi
+      fi
+    elif [ ${Period} -eq 1 ] ; then
+      # if not FirstInitialize and first loop of this job
+
+      # Restore Restarts files
+      #-----------------------
+      if ( [ X${FileName0} != X${NULL_STR} ] && [ X${FileName0} != XNONE ] ) ; then
+	eval NbFiles=\${#${ListFilesName}[@]} > /dev/null 2>&1
+
+	(( i=1 ))
+	until [ $i -gt $NbFiles ]; do
+	  eval file_in_=\${${ListFilesName}[$i]} > /dev/null 2>&1
+	  eval file_in=${file_in_}
+	  (( i_ = i+1 ))
+	  eval file_out_=\${${ListFilesName}[$i_]} > /dev/null 2>&1
+	  eval file_out=${file_out_}
+	  
+	  file_in_Name=${run_Configuration_OldPrefix}_${file_in}
+
+	  generic_restart_file_name_in=$( basename ${file_in_Name} .nc )
+	  generic_restart_file_name_out=$( basename ${file_out} .nc )
+
+	  eval Path_BUF=\${R_BUF_${comp}_R}/${generic_restart_file_name_in}
+	  eval Path_OUT=\${R_OUT_${comp}_R}/${generic_restart_file_name_in}
+
+	  if [ -f ${Path_BUF}*.nc ] ; then
+	    Buffered=true
+	    nb_restart_file=$(IGCM_sys_CountFileBuffer ${Path_BUF}_????.nc)
+	  else
+	    Buffered=false
+	    nb_restart_file=$(IGCM_sys_CountFileArchive ${Path_OUT}_????.nc)
+	  fi
+
+	  if [ ${nb_restart_file} -gt 1 ] ; then
+	    j=0
+	    until [ $j -ge $nb_restart_file ]; do
+	      j4=${j}
+	      if [ ${Buffered} ] ; then
+		IGCM_sys_GetBuffer ${Path_BUF}_${j4}.nc ${generic_restart_file_name_out}_${j4}.nc
+	      else
+		IGCM_sys_Get ${Path_OUT}_${j4}.nc ${generic_restart_file_name_out}_${j4}.nc
+	      fi
+	      (( j=j+1 ))
+	    done
+	  else
+	    if [ ${Buffered} ] ; then
+	      eval IGCM_sys_GetBuffer \${R_BUF_${comp}_R}/${file_in_Name} ${file_out}
 	    else
-		if [ X${FileName0} != XNONE ] ; then
-		    IGCM_debug_Exit "IGCM_comp_GetInputRestartFiles : No file in list for ${compname}."
-		else
-		    IGCM_debug_Print 1 "IGCM_comp_GetInputRestartFiles : NONE specified in Restart List ${compname}."
-		fi
-	    fi
+	      eval IGCM_sys_Get \${R_OUT_${comp}_R}/${file_in_Name} ${file_out}
+	    fi
+	  fi
+
+	  (( i=i+3 ))
+	done
+      else
+	if [ X${FileName0} != XNONE ] ; then
+	  IGCM_debug_Exit "IGCM_comp_GetInputRestartFiles : No file in list for ${compname}."
+	else
+	  IGCM_debug_Print 1 "IGCM_comp_GetInputRestartFiles : NONE specified in Restart List ${compname}."
 	fi
-    done
-
-    typeset NbFichs
-    NbFiles=$( ls * 2> /dev/null | wc -l )
-    if [ ${NbFiles} -gt 0 ] ; then
-	IGCM_sys_Chmod u+rw *
-    fi
-
-    IGCM_debug_PopStack "IGCM_comp_GetInputRestartFiles"
+      fi
+    fi
+  done
+
+  NbFiles=$( ls * 2> /dev/null | wc -l )
+  if [ ${NbFiles} -gt 0 ] ; then
+    IGCM_sys_Chmod u+rw *
+  fi
+
+  IGCM_debug_PopStack "IGCM_comp_GetInputRestartFiles"
 }
 
@@ -721,30 +775,30 @@
 function IGCM_comp_PeriodStart
 {
-    IGCM_debug_PushStack "IGCM_comp_PeriodStart"
-
-    # Debug Print :
-    echo
-    IGCM_debug_Print 1 "IGCM_comp_PeriodStart"
-    echo
-
-    typeset ExeNameIn ExeNameOut 
-    typeset comp compname comptagname
-    for comp in ${config_ListOfComponents[*]} ; do
-	# Define component 
-	eval compname=\${config_ListOfComponents_${comp}[0]} > /dev/null 2>&1
-	eval comptagname=\${config_ListOfComponents_${comp}[1]} > /dev/null 2>&1
-
-	# Copy executable for this component
-	eval ExeNameIn=\${config_Executable_${comp}[0]}
-	eval ExeNameOut=\${config_Executable_${comp}[1]}
-
-	# Debug Print
-	IGCM_debug_Print 3 "PeriodStart ${compname} Driver Function (if any)."
-	# UPDATE component
-        ${comp}_PeriodStart 2> /dev/null
-
-    done
-
-    IGCM_debug_PopStack "IGCM_comp_PeriodStart"
+  IGCM_debug_PushStack "IGCM_comp_PeriodStart"
+
+  # Debug Print :
+  echo
+  IGCM_debug_Print 1 "IGCM_comp_PeriodStart"
+  echo
+
+  typeset ExeNameIn ExeNameOut 
+  typeset comp compname comptagname
+  for comp in ${config_ListOfComponents[*]} ; do
+    # Define component 
+    eval compname=\${config_ListOfComponents_${comp}[0]} > /dev/null 2>&1
+    eval comptagname=\${config_ListOfComponents_${comp}[1]} > /dev/null 2>&1
+
+    # Copy executable for this component
+    eval ExeNameIn=\${config_Executable_${comp}[0]}
+    eval ExeNameOut=\${config_Executable_${comp}[1]}
+
+    # Debug Print
+    IGCM_debug_Print 3 "PeriodStart ${compname} Driver Function (if any)."
+    # UPDATE component
+    ${comp}_PeriodStart 2> /dev/null
+
+  done
+
+  IGCM_debug_PopStack "IGCM_comp_PeriodStart"
 }
 
@@ -752,47 +806,47 @@
 function IGCM_comp_Update
 {
-    IGCM_debug_PushStack "IGCM_comp_Update"
+  IGCM_debug_PushStack "IGCM_comp_Update"
 
     # Debug Print :
-    echo
-    IGCM_debug_Print 1 "IGCM_comp_Update"
-    echo
-
-    typeset ExeNameIn ExeNameOut 
-    typeset comp compname comptagname
-    for comp in ${config_ListOfComponents[*]} ; do
-	# Define component 
-	eval compname=\${config_ListOfComponents_${comp}[0]} > /dev/null 2>&1
-	eval comptagname=\${config_ListOfComponents_${comp}[1]} > /dev/null 2>&1
-
-	# Copy executable for this component
-	eval ExeNameIn=\${config_Executable_${comp}[0]}
-	eval ExeNameOut=\${config_Executable_${comp}[1]}
-
-	# If missing executable and DRYRUN is set to 0 or 1  then stop!
-	if [ ${DRYRUN} -le 1 ] && [ X${ExeNameIn} != X\"\" ] &&  [ ! -f ${R_EXE}/${ExeNameIn} ] ; then
-	    IGCM_debug_Exit "IGCM_comp_Update missing executable ${ExeNameIn}"
-	fi 
-
-	if [ ${Period} -eq 1 ] && [ -f ${R_EXE}/${ExeNameIn} ] ; then
-	    eval IGCM_sys_Cp ${R_EXE}/${ExeNameIn} ${ExeNameOut}
-	    if [ -f ${RUN_DIR}/${ExeNameOut} ] ; then
-                eval IGCM_sys_Chmod +rx ${RUN_DIR}/${ExeNameOut}
-	    fi
-	elif [ -f ${R_EXE}/${ExeNameIn} ] && [ ! -f ${RUN_DIR}/${ExeNameOut} ] ; then
-	    eval IGCM_sys_Cp ${R_EXE}/${ExeNameIn} ${ExeNameOut}
-	    if [ -f ${RUN_DIR}/${ExeNameOut} ] ; then
-                eval IGCM_sys_Chmod +rx ${RUN_DIR}/${ExeNameOut}
-	    fi
-	fi
-
-	# Debug Print
-	IGCM_debug_Print 1 "Update ${compname} Parameter Files."
-	# UPDATE component
-        ${comp}_Update
-
-    done
-
-    IGCM_debug_PopStack "IGCM_comp_Update"
+  echo
+  IGCM_debug_Print 1 "IGCM_comp_Update"
+  echo
+
+  typeset ExeNameIn ExeNameOut 
+  typeset comp compname comptagname
+  for comp in ${config_ListOfComponents[*]} ; do
+    # Define component 
+    eval compname=\${config_ListOfComponents_${comp}[0]} > /dev/null 2>&1
+    eval comptagname=\${config_ListOfComponents_${comp}[1]} > /dev/null 2>&1
+
+    # Copy executable for this component
+    eval ExeNameIn=\${config_Executable_${comp}[0]}
+    eval ExeNameOut=\${config_Executable_${comp}[1]}
+
+    # If missing executable and DRYRUN is set to 0 or 1  then stop!
+    if [ ${DRYRUN} -le 1 ] && [ X${ExeNameIn} != X\"\" ] &&  [ ! -f ${R_EXE}/${ExeNameIn} ] ; then
+      IGCM_debug_Exit "IGCM_comp_Update missing executable ${ExeNameIn}"
+    fi 
+
+    if [ ${Period} -eq 1 ] && [ -f ${R_EXE}/${ExeNameIn} ] ; then
+      eval IGCM_sys_Cp ${R_EXE}/${ExeNameIn} ${ExeNameOut}
+      if [ -f ${RUN_DIR}/${ExeNameOut} ] ; then
+        eval IGCM_sys_Chmod +rx ${RUN_DIR}/${ExeNameOut}
+      fi
+    elif [ -f ${R_EXE}/${ExeNameIn} ] && [ ! -f ${RUN_DIR}/${ExeNameOut} ] ; then
+      eval IGCM_sys_Cp ${R_EXE}/${ExeNameIn} ${ExeNameOut}
+      if [ -f ${RUN_DIR}/${ExeNameOut} ] ; then
+        eval IGCM_sys_Chmod +rx ${RUN_DIR}/${ExeNameOut}
+      fi
+    fi
+
+    # Debug Print
+    IGCM_debug_Print 1 "Update ${compname} Parameter Files."
+    # UPDATE component
+    ${comp}_Update
+
+  done
+
+  IGCM_debug_PopStack "IGCM_comp_Update"
 }
 
